=== debian/changelog ===
hashcat (7.1.2+ds1-3) unstable; urgency=medium

  * Move to unstable.
  * debian/patches
    + Refresfh fix_ftbfs_in_arm.diff to fix i386 build.

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 25 Oct 2025 17:49:24 -0500

hashcat (7.1.2+ds1-2) experimental; urgency=medium

  * debian/patches
    + Add fix_ftbfs_in_arm.diff patch.
      + Fix FTBFS in Armhf arch.

 -- Daniel Echeverri <epsilon@debian.org>  Wed, 01 Oct 2025 22:53:08 -0500

hashcat (7.1.2+ds1-1) experimental; urgency=medium

  * New upstream release.
  * debian/control
    + Update my lastname and email.
    + Bump Standards-Version to 4.7.2 (no change)
    + Add python3 in Suggests field.
    + Use wrap-and-sort.
  * debian/patches
    + Add fix_correct_path_bridges.diff
      + Adjust default Python/Rust bridge paths.
    + Refresh Don-t-strip-executables-when-DEBUG-0.patch
    + Refresh Update-shebangs.patch
    + Refresh add_kfreebsd_support.diff
    + Refresh fix-spelling-error.patch
    + Refresh fix_makefile.patch
  * debian/hashcat.links
    + Add new links for python plugin.
  * debian/hashcat.install
    + Install new scripts and new bridges.
  * debian/rules
    + Add MAINTAINER_MODE flag.
  * debian/copyright
    + Use cme to update copyright file.
    + Update my lastname and email.
  * debian/watch
    + update watch file: use file format 5.

 -- Daniel Echeverri <epsilon@debian.org>  Sun, 21 Sep 2025 10:54:24 -0500
