=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -lminizip

ifeq (armhf, $(DEB_HOST_ARCH))
        export DEB_CFLAGS_MAINT_APPEND = -mfpu=vfpv3-d16
endif

MAKEFILE_VARIABLES = PREFIX=/usr COMPTIME=$(SOURCE_DATE_EPOCH) USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1 USE_SYSTEM_ZLIB=1 ENABLE_UNRAR=0 MAINTAINER_MODE=1

%:
	dh $@


override_dh_auto_build:
	dh_auto_build -- $(MAKEFILE_VARIABLES)

override_dh_auto_install:
	dh_auto_install -- INSTALL="install" $(MAKEFILE_VARIABLES)

override_dh_install:
	rm -f debian/tmp/usr/share/doc/hashcat/docs/changes.txt
	rm -f debian/tmp/usr/share/doc/hashcat/docs/license.txt
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs docs/changes.txt

override_dh_fixperms-indep:
	dh_fixperms
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example0.sh
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example400.sh
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example500.sh
