=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: s/\+ds\d*$//
Owner: hashcat
Project: hashcat
Repacksuffix: +ds1
